/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using MPLAB Code Configurator

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB Code Configurator - v2.25.2
        Device            :  PIC16F1619
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC8 v1.34
        MPLAB             :  MPLAB X v2.35 or v3.00
 */

/*
Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 */

#include "mcc_generated_files/mcc.h"

/*
                         Main application
 */
void main(void) {
	uint8_t rxBuf[64];
	uint8_t indx;
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();
    
    indx = 0;
 	CMD_SetLow(); 
 	WAKEHW_SetHigh();
    WAKESW_SetLow();
    __delay_ms(100);
    WAKESW_SetHigh();
    __delay_ms(2000);

    indx = 0;
    if(EUSART_DataReady)
    {
        do{
            rxBuf[indx++] = EUSART_Read();
        }while(EUSART_DataReady);
    }
    if(rxBuf[0] == 'C' && \
       rxBuf[1] == 'M' && \
       rxBuf[2] == 'D')
    {
        indx = 0;
        printf("SR,32000000\r\n");
        __delay_ms(500);
        if(EUSART_DataReady)
        {
            do{
                rxBuf[indx++] = EUSART_Read();
            }while(EUSART_DataReady);
        }
    }
    if(rxBuf[0] == 'A' && \
       rxBuf[1] == 'O' && \
       rxBuf[2] == 'K')
    {
        indx = 0;
        printf("R,1\r\n");
        __delay_ms(1000);
        
        if(EUSART_DataReady)
        {
            do{
                rxBuf[indx++] = EUSART_Read();
            }while(EUSART_DataReady);
        }
    }
    if(rxBuf[0] == 'R' && \
       rxBuf[1] == 'e' && \
       rxBuf[2] == 'b' && \
       rxBuf[3] == 'o' && \
       rxBuf[4] == 'o' && \
       rxBuf[5] == 't')
    {
        indx = 0;
        __delay_ms(1000);
        if(EUSART_DataReady)
        {        
            
            do{
                rxBuf[indx++] = EUSART_Read();
            }while(EUSART_DataReady);
        }
        
    }
     if(rxBuf[0] == 'C' && \
        rxBuf[1] == 'M' && \
        rxBuf[2] == 'D')
     {
         //Device should be advertising here.
     }

    indx = 0;
    do{
     if(EUSART_DataReady)
     {   
         do{
             rxBuf[indx] = EUSART_Read();
             if(rxBuf[indx] == '~')
             {
                 OURLED_Toggle();
             }
         }while(EUSART_DataReady);
     }
  }while(1);
}
/**
 End of File
 */