/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB Code Configurator - v2.25.2
        Device            :  PIC16F1619
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 v1.34
        MPLAB             :  MPLAB X v2.35 or v3.00
 */

/*
Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 */

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set CONNECT aliases
#define CONNECT_TRIS               TRISA5
#define CONNECT_LAT                LATA5
#define CONNECT_PORT               RA5
#define CONNECT_SetHigh()    do { LATA5 = 1; } while(0)
#define CONNECT_SetLow()   do { LATA5 = 0; } while(0)
#define CONNECT_Toggle()   do { LATA5 = ~LATA5; } while(0)
#define CONNECT_GetValue()         RA5
#define CONNECT_SetDigitalInput()    do { TRISA5 = 1; } while(0)
#define CONNECT_SetDigitalOutput()   do { TRISA5 = 0; } while(0)

// get/set RX aliases
#define RX_TRIS               TRISB5
#define RX_LAT                LATB5
#define RX_PORT               RB5
#define RX_ANS                ANSB5
#define RX_SetHigh()    do { LATB5 = 1; } while(0)
#define RX_SetLow()   do { LATB5 = 0; } while(0)
#define RX_Toggle()   do { LATB5 = ~LATB5; } while(0)
#define RX_GetValue()         RB5
#define RX_SetDigitalInput()    do { TRISB5 = 1; } while(0)
#define RX_SetDigitalOutput()   do { TRISB5 = 0; } while(0)

#define RX_SetAnalogMode()   do { ANSB5 = 1; } while(0)
#define RX_SetDigitalMode()   do { ANSB5 = 0; } while(0)
// get/set TX aliases
#define TX_TRIS               TRISB7
#define TX_LAT                LATB7
#define TX_PORT               RB7
#define TX_WPU                WPUB7
#define TX_SetHigh()    do { LATB7 = 1; } while(0)
#define TX_SetLow()   do { LATB7 = 0; } while(0)
#define TX_Toggle()   do { LATB7 = ~LATB7; } while(0)
#define TX_GetValue()         RB7
#define TX_SetDigitalInput()    do { TRISB7 = 1; } while(0)
#define TX_SetDigitalOutput()   do { TRISB7 = 0; } while(0)

#define TX_SetPullup()    do { WPUB7 = 1; } while(0)
#define TX_ResetPullup()   do { WPUB7 = 0; } while(0)
// get/set IO_RC0 aliases
#define IO_RC0_TRIS               TRISC0
#define IO_RC0_LAT                LATC0
#define IO_RC0_PORT               RC0
#define IO_RC0_ANS                ANSC0
#define IO_RC0_SetHigh()    do { LATC0 = 1; } while(0)
#define IO_RC0_SetLow()   do { LATC0 = 0; } while(0)
#define IO_RC0_Toggle()   do { LATC0 = ~LATC0; } while(0)
#define IO_RC0_GetValue()         RC0
#define IO_RC0_SetDigitalInput()    do { TRISC0 = 1; } while(0)
#define IO_RC0_SetDigitalOutput()   do { TRISC0 = 0; } while(0)

#define IO_RC0_SetAnalogMode()   do { ANSC0 = 1; } while(0)
#define IO_RC0_SetDigitalMode()   do { ANSC0 = 0; } while(0)
// get/set CTS aliases
#define CTS_TRIS               TRISC1
#define CTS_LAT                LATC1
#define CTS_PORT               RC1
#define CTS_ANS                ANSC1
#define CTS_SetHigh()    do { LATC1 = 1; } while(0)
#define CTS_SetLow()   do { LATC1 = 0; } while(0)
#define CTS_Toggle()   do { LATC1 = ~LATC1; } while(0)
#define CTS_GetValue()         RC1
#define CTS_SetDigitalInput()    do { TRISC1 = 1; } while(0)
#define CTS_SetDigitalOutput()   do { TRISC1 = 0; } while(0)

#define CTS_SetAnalogMode()   do { ANSC1 = 1; } while(0)
#define CTS_SetDigitalMode()   do { ANSC1 = 0; } while(0)
// get/set WAKEHW aliases
#define WAKEHW_TRIS               TRISC3
#define WAKEHW_LAT                LATC3
#define WAKEHW_PORT               RC3
#define WAKEHW_ANS                ANSC3
#define WAKEHW_SetHigh()    do { LATC3 = 1; } while(0)
#define WAKEHW_SetLow()   do { LATC3 = 0; } while(0)
#define WAKEHW_Toggle()   do { LATC3 = ~LATC3; } while(0)
#define WAKEHW_GetValue()         RC3
#define WAKEHW_SetDigitalInput()    do { TRISC3 = 1; } while(0)
#define WAKEHW_SetDigitalOutput()   do { TRISC3 = 0; } while(0)

#define WAKEHW_SetAnalogMode()   do { ANSC3 = 1; } while(0)
#define WAKEHW_SetDigitalMode()   do { ANSC3 = 0; } while(0)
// get/set OURLED aliases
#define OURLED_TRIS               TRISC5
#define OURLED_LAT                LATC5
#define OURLED_PORT               RC5
#define OURLED_WPU                WPUC5
#define OURLED_SetHigh()    do { LATC5 = 1; } while(0)
#define OURLED_SetLow()   do { LATC5 = 0; } while(0)
#define OURLED_Toggle()   do { LATC5 = ~LATC5; } while(0)
#define OURLED_GetValue()         RC5
#define OURLED_SetDigitalInput()    do { TRISC5 = 1; } while(0)
#define OURLED_SetDigitalOutput()   do { TRISC5 = 0; } while(0)

#define OURLED_SetPullup()    do { WPUC5 = 1; } while(0)
#define OURLED_ResetPullup()   do { WPUC5 = 0; } while(0)
// get/set WAKESW aliases
#define WAKESW_TRIS               TRISC6
#define WAKESW_LAT                LATC6
#define WAKESW_PORT               RC6
#define WAKESW_ANS                ANSC6
#define WAKESW_SetHigh()    do { LATC6 = 1; } while(0)
#define WAKESW_SetLow()   do { LATC6 = 0; } while(0)
#define WAKESW_Toggle()   do { LATC6 = ~LATC6; } while(0)
#define WAKESW_GetValue()         RC6
#define WAKESW_SetDigitalInput()    do { TRISC6 = 1; } while(0)
#define WAKESW_SetDigitalOutput()   do { TRISC6 = 0; } while(0)

#define WAKESW_SetAnalogMode()   do { ANSC6 = 1; } while(0)
#define WAKESW_SetDigitalMode()   do { ANSC6 = 0; } while(0)
// get/set CMD aliases
#define CMD_TRIS               TRISC7
#define CMD_LAT                LATC7
#define CMD_PORT               RC7
#define CMD_ANS                ANSC7
#define CMD_SetHigh()    do { LATC7 = 1; } while(0)
#define CMD_SetLow()   do { LATC7 = 0; } while(0)
#define CMD_Toggle()   do { LATC7 = ~LATC7; } while(0)
#define CMD_GetValue()         RC7
#define CMD_SetDigitalInput()    do { TRISC7 = 1; } while(0)
#define CMD_SetDigitalOutput()   do { TRISC7 = 0; } while(0)

#define CMD_SetAnalogMode()   do { ANSC7 = 1; } while(0)
#define CMD_SetDigitalMode()   do { ANSC7 = 0; } while(0)

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    GPIO and peripheral I/O initialization
 * @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize(void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);

#endif // PIN_MANAGER_H
/**
 End of File
 */